io.undertow.websockets.core.protocol.version07

## Class WebSocket07FrameSinkChannel

- java.lang.Object
- - io.undertow.server.protocol.framed.AbstractFramedStreamSinkChannel<WebSocketChannel,StreamSourceFrameChannel,StreamSinkFrameChannel>
  - - io.undertow.websockets.core.StreamSinkFrameChannel
    - - io.undertow.websockets.core.protocol.version07.WebSocket07FrameSinkChannel

All Implemented Interfaces:
  Closeable, AutoCloseable, Channel, GatheringByteChannel, InterruptibleChannel, WritableByteChannel, org.xnio.channels.CloseableChannel, org.xnio.channels.Configurable, org.xnio.channels.StreamSinkChannel, org.xnio.channels.SuspendableWriteChannel

    public abstract class WebSocket07FrameSinkChannel
    extends StreamSinkFrameChannel

`StreamSinkFrameChannel` implementation for writing WebSocket Frames on `WebSocketVersion.V08` connections

Author:
  Norman Maurer

### Field Summary

Fields
`protected ExtensionFunction` `extensionFunction`

### Fields inherited from interface org.xnio.channels.Configurable

`EMPTY`

### Constructor Summary

Constructors
`protected` `WebSocket07FrameSinkChannel(WebSocket07Channel wsChannel, WebSocketFrameType type)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected SendFrameHeader` `createFrameHeader()`
`protected void` `handleFlushComplete(boolean finalFrame)`
`protected PooledByteBuffer` `preWriteTransform(PooledByteBuffer body)`

### Methods inherited from class io.undertow.websockets.core.StreamSinkFrameChannel

`areExtensionsSupported, getRsv, getType, getWebSocketChannel, isFinalFragment, isFragmentationSupported, isLastFrame, setRsv`

### Methods inherited from class io.undertow.server.protocol.framed.AbstractFramedStreamSinkChannel

`awaitWritable, awaitWritable, channelForciblyClosed, close, flush, getAwaitWritableTimeout, getBuffer, getChannel, getCloseSetter, getIoThread, getOption, getWorker, getWriteSetter, getWriteThread, isBroken, isBufferFull, isFinalFrameQueued, isFirstDataWritten, isFlushRequiredOnEmptyBuffer, isOpen, isReadyForFlush, isWriteResumed, isWritesShutdown, markBroken, resumeWrites, resumeWritesInternal, safeToSend, send, sendInternal, setOption, shutdownWrites, supportsOption, suspendWrites, transferFrom, transferFrom, wakeupWrites, write, write, write, writeFinal, writeFinal, writeFinal`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### extensionFunction

    protected final ExtensionFunction extensionFunction

### Constructor Detail

#### WebSocket07FrameSinkChannel

    protected WebSocket07FrameSinkChannel(WebSocket07Channel wsChannel,
                                          WebSocketFrameType type)

### Method Detail

#### handleFlushComplete

    protected void handleFlushComplete(boolean finalFrame)

Overrides:
  `handleFlushComplete` in class `AbstractFramedStreamSinkChannel<WebSocketChannel,StreamSourceFrameChannel,StreamSinkFrameChannel>`

#### createFrameHeader

    protected SendFrameHeader createFrameHeader()

Overrides:
  `createFrameHeader` in class `AbstractFramedStreamSinkChannel<WebSocketChannel,StreamSourceFrameChannel,StreamSinkFrameChannel>`

#### preWriteTransform

    protected PooledByteBuffer preWriteTransform(PooledByteBuffer body)

Overrides:
  `preWriteTransform` in class `AbstractFramedStreamSinkChannel<WebSocketChannel,StreamSourceFrameChannel,StreamSinkFrameChannel>`